#include <stdio.h>
#include "nsf_types.h"
#include "NSF_Core.h"
#include "NSF_File.h"

BYTE buf[0x1000+200];

int main(int argc, char ** argv) {
    FILE * outfile;
    int i, written;

    if (argc != 2 && argc!=3) {printf("usage: %s file.nsf [track]\n",argv[0]); return 1;}

    if(LoadFile(argv[1],1,0)) {printf("LoadFile failed\n"); return 1;}
	
    if(!NSFCore_Initialize()) {printf("NSFCore_Initialize failed\n"); return 1;}

    if(!SetPlaybackOptions(44100,1)) {printf("SetPlaybackOptions failed\n"); return 1;}
    if(!LoadNSF()) {printf("LoadNSF failed\n"); return 1;}

    if (argc==3)
	SetTrack(atoi(argv[2]));
    else
	SetTrack(nInitialTrack);

    outfile = fopen("raw.out","wb");
    if (!outfile) {printf("error opening raw.out\n"); return 1;}
    for (i=0;i<0x100;i++) {
    	written=GetSamples(buf,0x1000/4);
    	fwrite(buf,written,1,outfile);
    }
    fclose(outfile); outfile=NULL;

    return 0;
}
